package info.bukova.isspst.ui.requirement;

import info.bukova.isspst.data.RequirementBase;
import info.bukova.isspst.data.User;
import info.bukova.isspst.services.requirement.RequirementBaseService;
import info.bukova.isspst.services.users.UserService;
import info.bukova.isspst.ui.BigDecimalConverter;
import info.bukova.isspst.ui.ListViewModel;
import info.bukova.isspst.ui.renderers.RequirementsItemRenderer;

import java.util.List;

import org.zkoss.bind.BindUtils;
import org.zkoss.bind.annotation.Command;
import org.zkoss.bind.annotation.Init;
import org.zkoss.bind.annotation.NotifyChange;
import org.zkoss.zk.ui.select.annotation.WireVariable;

public class RequirementSubpage<T extends RequirementBase> extends ListViewModel<T> {
	
	@WireVariable
	protected UserService userService;

	protected RequirementsItemRenderer requirementsItemRenderer;

	public List<User> getAllUsers()
	{
		return userService.getAll();
	}

	private BigDecimalConverter bigDecimalConverter;

	public BigDecimalConverter getBigDecimalConverter()
	{
		return bigDecimalConverter;
	}

	public void setBigDecimalConverter(BigDecimalConverter bigDecimalConverter)
	{
		this.bigDecimalConverter = bigDecimalConverter;
	}

	@Init(superclass = true)
	public void initRequirementSubpage()
	{
		this.bigDecimalConverter = new BigDecimalConverter();
		this.requirementsItemRenderer = new RequirementsItemRenderer();
	}

	private RequirementBaseService<T> getReqService()
	{
		return (RequirementBaseService<T>) service;
	}
	
	@Command
	@NotifyChange({"dataBean", "canApprove"})
	public void approve() {
		this.getReqService().approve(getDataBean());
		BindUtils.postGlobalCommand(null, null, "reload", null);
	}

	@Override
	@NotifyChange({ "dataBean", "ableToDelete", "canApprove" })
	public void setDataBean(T data) {
		super.setDataBean(data);
	}
	
	public boolean isCanApprove() {
		if (getDataBean() != null) {
			return this.getReqService().canApprove(getDataBean());
		}
		
		return false;
	}

	public RequirementsItemRenderer getRequirementsItemRenderer()
	{
		return requirementsItemRenderer;
	}

	public void setRequirementsItemRenderer(RequirementsItemRenderer requirementsItemRenderer)
	{
		this.requirementsItemRenderer = requirementsItemRenderer;
	}

	@Override
	protected void afterSelect() {
		BindUtils.postNotifyChange(null, null, this, "canApprove");
	}
}
